#= iEPG\f[^NX
#
# t@C\f[^ǂݎB
#
#=== Ql
#
#* {iEPGtH[}bg \350ml.net\}[http://350ml.net/labo/iepg.html]
#
#=== iEPGΉTCg
#* {֗ȃerԑg\yGKCh.erz}[http://tv.so-net.ne.jp/]
#* {C^[lbgTVKCh}[http://www.tvguide.or.jp/]
#
class IEPG

  # Rec^Cv(application/x-tv-program-info; charset=shift_jis)
  attr_reader :content_type

  # o[W(1)
  attr_reader :version

  # ǖ
  attr_reader :station

  # ^Jn̐(yyyy)
  attr_reader :year

  # ^Jň(mm)
  attr_reader :month

  # ^\t(dd)
  attr_reader :date

  # ^Jn(hh:mm)
  attr_reader :start

  # ^I(hh:mm)
  attr_reader :end

  # ԑg^Cg
  attr_reader :program_title

  # ԑgTu^Cg
  attr_reader :program_subtitle

  # ԑgTv
  attr_reader :program_synopsis

  # W
  attr_reader :genre

  # TuW
  attr_reader :subgenre

  # o
  attr_reader :performer

  #=== RXgN^
  #
  # iEPGt@CǂݍŏB
  #
  #_file_name_:: Ώtvpit@CpX
  #
  def initialize(file_name)
    file_array = read_array(file_name)
    tvpi = file_array[0].strip
    memo = file_array[1].strip

    raise "t@CsłB[file_array=#{file_array}]" if tvpi.nil?
    raise "t@CsłB[file_array=#{file_array}]" if memo.nil?

    @program_synopsis = memo
    @content_type     = read_header(tvpi, 'Content-type')
    @version          = read_header(tvpi, 'version')
    @station          = read_header(tvpi, 'station')
    @year             = read_header(tvpi, 'year')
    @month            = read_header(tvpi, 'month')
    @date             = read_header(tvpi, 'date')
    @start            = read_header(tvpi, 'start')
    @end              = read_header(tvpi, 'end')
    @program_title    = read_header(tvpi, 'program-title')
    @program_subtitle = read_header(tvpi, 'program-subtitle', false)
    @genre            = read_header(tvpi, 'genre', false)
    @subgenre         = read_header(tvpi, 'subgenre', false)
    @performer        = read_header(tvpi, 'performer', false)
  end

private

  #=== wb_[f[^ǂݎ
  #
  # read_arrayœǂݍ񂾃wb_[񂩂A
  # nameŎw肵wb_[̒lǂݎB
  #
  #_tvpi_:: wb_[
  #_name_:: wb_[
  #_required_:: K{`FbN̗L
  #
  #_return_:: nameŎw肵wb_[̒l
  #
  def read_header(tvpi, name, required = true)
    match = tvpi[/^#{name}:(.+)$/i, 1]

    if required
      if match.nil? or match.strip == ''
        raise "#{name}͕K{ڂłB"
      end
    end

    return nil if match.nil?
    res = match.strip
    return (res == '') ? nil : res
  end

  #=== t@CŜǂݍ
  #
  # t@Cǂݍ݁AƂăwb_[ƃ
  # zɊi[AԋpB
  #
  #_file_name_:: Ώtvpit@CpX
  #
  #_return_:: ['wb_[', '']
  #
  def read_array(file_name)
    buf = ''
    line_c = 0

    File.open(file_name, 'r') do |f|
      while str = f.gets
        buf << str
        line_c += 1
      end
    end

    raise "K{ڂ܂B" unless line_c > 5

    return buf.split(/^$[\r\n]+/, 2)
  end

end
