require 'win32ole'
require 'scheinfo'

#= WXgƒڂƂ肷NX
#
class Registry

  #=== RXgN^
  #
  # WXg̃ANZXWSHgpB
  #
  def initialize
    @wsh = WIN32OLE.new('WScript.Shell')
  end

  #=== WXgǂݎ
  #
  # z̈ɃWXg̃L[w肵A
  # L[̒l擾B
  #
  #_keyname_:: WXgL[ "ScheInfoXX"
  #
  #_return_:: \IuWFNg
  #
  def [](keyname)
    param = {}
    param[:bHiddenRecord]   = @wsh.RegRead(regname(keyname, 'bHiddenRecord'))
    param[:iChnIndex]       = @wsh.RegRead(regname(keyname, 'iChnIndex'))
    param[:iFreqFlag]       = @wsh.RegRead(regname(keyname, 'iFreqFlag'))
    param[:iPowerShutType]  = @wsh.RegRead(regname(keyname, 'iPowerShutType'))
    param[:iSrcType]        = @wsh.RegRead(regname(keyname, 'iSrcType'))
    param[:iStartDateTime]  = @wsh.RegRead(regname(keyname, 'iStartDateTime'))
    param[:iStatusFlag]     = @wsh.RegRead(regname(keyname, 'iStatusFlag'))
    param[:lActualDurMin]   = @wsh.RegRead(regname(keyname, 'lActualDurMin'))
    param[:lIntendedDurMin] = @wsh.RegRead(regname(keyname, 'lIntendedDurMin'))
    param[:szID]            = @wsh.RegRead(regname(keyname, 'szID'))
    param[:szPrgmSynopsis]  = @wsh.RegRead(regname(keyname, 'szPrgmSynopsis'))
    param[:szPrgmTitle]     = @wsh.RegRead(regname(keyname, 'szPrgmTitle'))
    return ScheInfo.new(param)
  end

  #=== WXg
  #
  # z̈ɃWXg̃L[w肵A
  # L[̒lݒ肷B
  #
  #_keyname_:: WXgL[ "ScheInfoXX"
  #_scheinfo_:: \IuWFNg
  #
  def []=(keyname, scheinfo)
    @wsh.RegWrite(regname(keyname, 'bHiddenRecord'),   scheinfo.bHiddenRecord,   'REG_SZ')
    @wsh.RegWrite(regname(keyname, 'iChnIndex'),       scheinfo.iChnIndex,       'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'iFreqFlag'),       scheinfo.iFreqFlag,       'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'iPowerShutType'),  scheinfo.iPowerShutType,  'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'iSrcType'),        scheinfo.iSrcType,        'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'iStartDateTime'),  scheinfo.iStartDateTime,  'REG_SZ')
    @wsh.RegWrite(regname(keyname, 'iStatusFlag'),     scheinfo.iStatusFlag,     'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'lActualDurMin'),   scheinfo.lActualDurMin,   'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'lIntendedDurMin'), scheinfo.lIntendedDurMin, 'REG_DWORD')
    @wsh.RegWrite(regname(keyname, 'szID'),            scheinfo.szID,            'REG_SZ')
    @wsh.RegWrite(regname(keyname, 'szPrgmSynopsis'),  scheinfo.szPrgmSynopsis,  'REG_SZ')
    @wsh.RegWrite(regname(keyname, 'szPrgmTitle'),     scheinfo.szPrgmTitle,     'REG_SZ')
  end

private

  #=== WXgL[쐬
  #
  # ZL[At̃L[쐬ĕԋpB
  #
  #_keyname_:: "ScheInfoXX"
  #_value_name_:: L[
  #
  #_return_:: 'HKCU\Software\SKNET\Legend\Scheduler\ScheInfo..\L['
  #
  def regname(keyname, value_name)
    reg_sche = 'HKCU\Software\SKNET\Legend\Scheduler\\'
    reg_sche << keyname << '\\' << value_name
    return reg_sche
  end

end
