require 'period'

#= \NX
#
class ScheInfo

  REGEXP_TIME = Period::REGEXP_START

  # \ID(yyyymmdd_hhmmss)
  attr_reader :szID

  # (s)
  attr_reader :iSrcType

  # `lCfbNX
  attr_reader :iChnIndex

  # ԑg
  attr_reader :szPrgmTitle

  # ԑg
  attr_reader :szPrgmSynopsis

  # Jn(yyyy:m:d:h:m:s)
  attr_reader :iStartDateTime

  # T\rbgtO
  attr_reader :iFreqFlag

  # \񎞊()
  attr_reader :lIntendedDurMin

  # ^掞()
  attr_reader :lActualDurMin

  # (s)
  attr_reader :bHiddenRecord

  # dǗ 0:Ȃ 1:X^oC 2:x~Ԃֈڍs
  attr_reader :iPowerShutType

  #  0:荏 1: 2:s 3: 4:^撆 6:܂ȂJn 7:~܂
  attr_reader :iStatusFlag

  #=== RXgN^
  #
  #_scheinfo_:: pAzz
  #
  def initialize(scheinfo)
    @szID            = scheinfo[:szID]
    @iSrcType        = scheinfo[:iSrcType]
    @iChnIndex       = scheinfo[:iChnIndex]
    @szPrgmTitle     = scheinfo[:szPrgmTitle]
    @szPrgmSynopsis  = scheinfo[:szPrgmSynopsis]
    @iStartDateTime  = scheinfo[:iStartDateTime]
    @iFreqFlag       = scheinfo[:iFreqFlag]
    @lIntendedDurMin = scheinfo[:lIntendedDurMin]
    @lActualDurMin   = scheinfo[:lActualDurMin]
    @bHiddenRecord   = scheinfo[:bHiddenRecord]
    @iPowerShutType  = scheinfo[:iPowerShutType]
    @iStatusFlag     = scheinfo[:iStatusFlag]
  end

  #=== \I`FbN
  #
  # ݂̎Ɨ\̎rA
  # ɗ\񎞍2O߂ĂtrueA
  # ȊOfalseԋp
  #
  #_return_:: \񎞍2O߂Ătrue
  #
  def over?
    t = Time.local($1, $2, $3, $4, $5) if REGEXP_TIME =~ @iStartDateTime
    now = Time.now + 2 * 60
    return (t - now <= 0)
  end

  #=== d\`FbN
  #
  # scheinfoIuWFNgƘ^掞ԂrA
  # ^掞ԂdȂĂtrueA
  # ȊOfalseԋp
  #
  #_scheinfo_:: Ώ
  #
  #_return_:: ^掞ԂdȂĂtrue
  #
  def duplicated?(scheinfo)
    a = Period.new(@iStartDateTime, @lIntendedDurMin)
    b = Period.new(scheinfo.iStartDateTime, scheinfo.lIntendedDurMin)
    return a.duplicated?(b)
  end

end
